#!/usr/bin/env ruby

require 'tk'

def cursor_window(top = nil)
  unless top.kind_of?(TkWindow)
    top = TkToplevel.new(:title=>'Cursor Window')
  end

  dx = 60
  dy = 50

  c = TkCanvas.new(top, :background=>'white', 
                   :width=>dx*10, :highlightthickness=>0, 
                   :borderwidth=>0).pack(:expand=>true, :fill=>:both)
  cursors = %w(
              X_cursor
              arrow
              based_arrow_down
              based_arrow_up
              boat
              bogosity
              bottom_left_corner
              bottom_right_corner
              bottom_side
              bottom_tee
              box_spiral
              center_ptr
              circle
              clock
              coffee_mug
              cross
              cross_reverse
              crosshair
              diamond_cross
              dot
              dotbox
              double_arrow
              draft_large
              draft_small
              draped_box
              exchange
              fleur
              gobbler
              gumby
              hand1
              hand2
              heart
              icon
              iron_cross
              left_ptr
              left_side
              left_tee
              leftbutton
              ll_angle
              lr_angle
              man
              middlebutton
              mouse
              pencil
              pirate
              plus
              question_arrow
              right_ptr
              right_side
              right_tee
              rightbutton
              rtl_logo
              sailboat
              sb_down_arrow
              sb_h_double_arrow
              sb_left_arrow
              sb_right_arrow
              sb_up_arrow
              sb_v_double_arrow
              shuttle
              sizing
              spider
              spraycan
              star
              target
              tcross
              top_left_arrow
              top_left_corner
              top_right_corner
              top_side
              top_tee
              trek
              ul_angle
              umbrella
              ur_angle
              watch
              xterm
    )

  orig_cursor = c.cursor
  col = 0
  row = 0

  cursors.each{|cur|
    x = col * dx
    y = row * dy

    begin
      c.cursor = cur

      r = TkcRectangle.new(c, x, y, x+dx, y+dy, 
                           :fill=>'gray90', :outline=>'black', :width=>2)
      t = TkcText.new(c, x+dx/2, y+4, :text=>cur, :anchor=>:n, :width=>dy+2)

      col += 1
      if col >= 10
        col = 0
        row += 1
      end

      r.bind('Enter', proc{c.cursor = cur; r.fill = 'linen'})
      r.bind('Leave', proc{c.cursor = ''; r.fill = 'gray90'})

      t.bind('Enter', proc{c.cursor = cur})
      t.bind('Leave', proc{c.cursor = ''})
    rescue
      c.cursor = orig_cursor
    end
  }

  c.cursor = orig_cursor
  c.height = (row + 1) * dy
end

cursor_window(Tk.root)

Tk.mainloop
