#
#  new_display_num.rb
#
#                             by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
require 'server/xvnc_options.rb'

module Free_Display_Num
  def is_free_display_num?(num)
    begin
      sock = TCPSocket.new('127.0.0.1', 6000 + num)
    rescue
      # may not exist
    else
      # exists
      sock.close if sock
      return false
    end

    # file check
    XVNC_CHECK_FILES_FOR_FREE_DISPLAY.each{|file_pattern|
      return false if FileTest.exist?(file_pattern % num)
    }

    return true
  end

  def get_free_display_num
    ((XVNC_DISPLAY_SEARCH_MIN)..(XVNC_DISPLAY_SEARCH_MAX)).each{|n|
      return n if is_free_display_num?(n)
    }
    return nil
  end
end
