#
#  xvnc_options.rb : defaults for Xvnc
#
#  NOTE: Some of following definitions may require modification (or addition)
#        depended on your environment.
#
DEFAULT_XVNC_PATH = '/usr/local/bin/Xvnc'
DEFAULT_XVNC_PROCESS_NAME = 'tkorca-Xvnc' # program name on process table

#################################################################
# params depend on the strategy how Xvnc search a free display.
XVNC_DISPLAY_SEARCH_MIN =  1
XVNC_DISPLAY_SEARCH_MAX = 99

XVNC_CHECK_FILES_FOR_FREE_DISPLAY = [
  '/tmp/.X%d-lock', 
  '/tmp/.X11-unix/X%d', 
  '/usr/spool/sockets/X11/%d', 
]

#################################################################

DEFAULT_XVNC_OPTION_LIST = {
  'inetd'          => true, 
  'once'           => true, 
  'localhost'      => false, 
  #'localhost'      => true, # may be useful in conjunction with SSH tunneling 
  'nocursor'       => false, 
  'lazytight'      => false, 
  'compatiblekbd'  => false, # TightVNC-specific
  'nevershared'    => true, 
  'desktop'        => 'Ruby/TkORCA', 
  'rfbauth'        => false, # Not use authentification
#  'geometry'       => '800x600', 
  'geometry'       => '768x576', 
  'depth'          => 24, 
  'pixelformat'    => nil, 
  #'pixelformat'    => 'rgb888', 
  'deferupdate'    => nil, 
  #'deferupdate'    => 40, 
  'economictranslate' => false, 
}

DEFAULT_XSERVER_OPTION_LIST = {
  'cc' => 4, 
  'fp' => 'unix/:7100,/usr/X11R6/lib/X11/fonts/japanese,/usr/X11R6/lib/X11/fonts/misc,/usr/X11R6/lib/X11/fonts/75dpi', 
#  'fp' => 'unix/:7100,/usr/X11R6/lib/X11/fonts/misc,/usr/X11R6/lib/X11/fonts/75dpi', 
#  'fp' => '/usr/X11R6/lib/X11/fonts/misc,/usr/X11R6/lib/X11/fonts/75dpi', 
}
