#
#  show_rubytk_version.rb : print out Ruby/Tk version information
#
#                             by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
puts "--------------------------------------------------------------------"
puts "Current Ruby = #{RUBY_VERSION} (#{RUBY_RELEASE_DATE}) [#{RUBY_PLATFORM}]"
puts "--------------------------------------------------------------------"

# check Ruby/Tk version  ( need to require, now )
unless require('multi-tk')
  puts "Ruby/Tk :: fail to require!!  Please check your environment."
else
  puts "RELEASE_DATE of Ruby/Tk  = #{Tk::RELEASE_DATE}"
  puts "                TkUtil   = #{TkUtil::RELEASE_DATE}"
  puts "                TclTkLib = #{TclTkLib::RELEASE_DATE}"
  puts "Compile Information about TclTkLib = \"#{TclTkLib::COMPILE_INFO}\""
  puts "--------------------------------------------------------------------"
  puts "Current Linked Tcl/Tk Library = " + 
    "Tcl#{Tk::TCL_PATCHLEVEL}/Tk#{Tk::TK_PATCHLEVEL}" + 
    ((Tk::PLATFORM['threaded'])? ' with native-thread': '')
  puts "Value of tcl_library = #{Tk::TCL_LIBRARY}"
  puts "         tk_library  = #{Tk::TK_LIBRARY}"
  puts "         tcl_pkgPath = #{Tk::PACKAGE_PATH.list.inspect}" rescue nil
  puts "         tcl_libPath = #{Tk::LIBRARY_PATH.list.inspect}" rescue nil
  puts "         auto_path   = #{Tk::AUTO_PATH.list.inspect}" rescue nil
end
