#
#  logger.rb : 
#
#                             by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
class TkORCA::CLIENT_LOGGER
  def initialize(fd, prefix = '')
    @fd = fd
    @prefix = prefix
    @ignore_write = false
    @out = IO.open(@fd, 'a')
    @writer = proc{|str| (@out.write(str) rescue nil) unless @ignore_write }
    @flusher = proc{ @out.flush rescue nil}
    @sync = true
    # self.log('logfile open')
  end

  def stop
    @ignore_write = true
  end

  def restart
    @ignore_write = false
  end

  def close
    @out.close
  end

  def closed?
    @out.closed?
  end

  def flush
    @flusher.call
  end

  def sync
    @sync
  end

  def sync=(new_st)
    @sync = (new_st)? true: false
  end

  def log(*strings)
    @writer.call(Time.now.strftime('%Y-%m-%d %H:%M:%S> ') + @prefix + 
                   (strings.join(' ').chomp) + "\n")
    @flusher.call if @sync
    self
  end

  def raw_write(*strings)
    @writer.call((strings.join(' ').chomp) + "\n")
    @flusher.call if @sync
    self
  end
end
