#
#  init_optiondb.rb : 
#
#    setup OptionDBs on current Tk interpreter,
#       when TkORCA::OptionDB.setup is called.
#
#    put definition files into `option_db' directory, 
#       and add information of applying order to `option_db/_setup_orer' file.
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
module TkORCA::OptionDB
  extend self

  @initializers = []

  def self.setup
    @initializers.each{|m| self.__send__(m) }
  end

  ##############################################

  def self.add_group(group, &b)
    define_method(group, &b)
  end

  def self.method_removed(m)
    @initializers.delete(m)
  end

  def self.method_undefined(m)
    @initializers.delete(m)
  end

  def self.method_added(m)
    @initializers.delete(m)
    @initializers << m
  end
end

###############################################
#  load defaults
###############################################
dir = File.join(File.dirname(File.expand_path(__FILE__)), 'option_db')

IO.foreach(File.join(dir, '_setup_order')){|line|
  line.strip!
  next if line =~ /^#/  ####
  load File.join(dir, line.split[0])
}
