#
#  tkorca/initialzie.rb : 
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#

#
#  create base module
#
module TkORCA
  LIB_DIR  = File.dirname(File.expand_path(__FILE__))
  BASE_DIR = File.dirname(LIB_DIR)

  CURRENT_STAGE = 'start_up'

  module OPTIONS
  end

  module Input_Method
  end
end

#
#  setup STAGE-1
#    setup parametaers before loading Ruby/Tk
#
TkORCA::CURRENT_STAGE.replace 'setup_stage1'
require 'tkorca/setup/stage1'

#
#  setup Input-Method
#
TkORCA::CURRENT_STAGE.replace 'setup_Input-Method'
if TkORCA::USE_INPUT_METHOD
  require "tkorca/input_method/#{TkORCA::USE_INPUT_METHOD.to_s.strip}"
  if TkORCA::Input_Method::START_UP_PROC
    TkORCA::Input_Method::PID = TkORCA::Input_Method::START_UP_PROC.call()
    sleep 1 # wait for starting up of IM
  else
    TkORCA::Input_Method::PID = nil
  end
else
  TkORCA::Input_Method::START_UP_PROC = nil
  TkORCA::Input_Method::PID = nil
end

#
#  load Ruby/Tk
#
TkORCA::CURRENT_STAGE.replace 'load_Ruby/Tk'
require 'multi-tk'

#
#  setup STAGE-2
#    setup parametaers after loading Ruby/Tk, but before starting an event-loop
#
TkORCA::CURRENT_STAGE.replace 'setup_stage2'
require 'tkorca/setup/stage2'

#
#  start an event-loop
#
TkORCA::CURRENT_STAGE.replace 'start_eventloop'
TkORCA::EVLOOP_THREAD = Thread.new{Tk.mainloop}

#
#  setup STAGE-3
#    setup parametaers after starting an event-loop
#
TkORCA::CURRENT_STAGE.replace 'setup_stage3'
require 'tkorca/setup/stage3'

#
#  require libraries of Ruby/TkORCA
#
TkORCA::CURRENT_STAGE.replace 'require_libraries'
require 'tkorca/setup/require_libs'

#
#  deny daughters from accessing instance_variables of TkORCA
#
module TkORCA
  def self.instance_variable_get(var)
    TkORCA.security_check()
    super(var)
  end

  def self.instance_variable_set(var, val)
    TkORCA.security_check()
    super(var, val)
  end
end


#
#  remove some global constants
#
TkORCA::CURRENT_STAGE.replace 'remove_global_constants'
require 'tkorca/setup/rm_global_consts'


#
#  complete initialization
#
TkORCA::CURRENT_STAGE.replace 'running'
