#
#  setup INPUT-METHOD : Kinput2 + Canna
#
module TkORCA::Input_Method
  ENV['XMODIFIERS']    = '@im=kinput2'
  ENV['GTK_IM_MODULE'] = 'xim'
  ENV['QT_IM_MODULE']  = 'xim'
  ENV['TK_KCPROTO']    = 'kinput2'
  ENV['XIM_PROG']      = 'canna'

  unless const_defined?('IM_SERVER')
    if (ENV['CANNA_SERVER'])
      IM_SERVER = ENV['CANNA_SERVER']
    else
      IM_SERVER = 'unix'
      # IM_SERVER = 'localhost'
    end
  end
  ENV['CANNA_SERVER'] = IM_SERVER

  unless const_defined?('IM_PROG')
    IM_PROG = '/usr/X11R6/bin/kinput2'
  end

  unless const_defined?('IM_CMD')
    IM_CMD = "#{IM_PROG} -display %1$s -canna -cannaserver #{IM_SERVER}"
  end

  unless const_defined?('START_UP_PROC')
    START_UP_PROC = proc{|*args|
      if args.empty?
        display = ENV['DISPLAY']
      else
        display = args.shift
      end
      if display.empty? || TkORCA::DISPLAYS_WITHOUT_IM_SETUP.index(display)
        nil
      else
        fork{ exec(IM_CMD % [display, *args]) }
      end
    }
  end
end
