#
#  setup INPUT-METHOD : Kinput2 + FreeWnn
#
module TkORCA::Input_Method
  ENV['XMODIFIERS']    = '@im=kinput2'
  ENV['GTK_IM_MODULE'] = 'xim'
  ENV['QT_IM_MODULE']  = 'xim'
  ENV['TK_KCPROTO']    = 'kinput2'
  ENV['XIM_PROG']      = 'FreeWnn'

  unless const_defined?('IM_SERVER')
    if (ENV['JSERVER'])
      IM_SERVER = ENV['JSERVER']
    else
      # IM_SERVER = 'unix'
      IM_SERVER = 'localhost'
    end
  end
  ENV['JSERVER'] = IM_SERVER

  unless const_defined?('IM_PROG')
    IM_PROG = '/usr/X11R6/bin/kinput2'
  end

  unless const_defined?('IM_RCPATH')
    IM_RCPATH = '/etc/FreeWnn/ja/wnnenvrc'
  end

  unless const_defined?('IM_CMD')
    IM_CMD = "#{IM_PROG} -display %1$s" + 
             " -wnn -jserver #{IM_SERVER} -wnnenvrc4 #{IM_RCPATH}"
  end

  unless const_defined?('START_UP_PROC')
    START_UP_PROC = proc{|*args|
      if args.empty?
        display = ENV['DISPLAY']
      else
        display = args.shift
      end
      if display.empty? || TkORCA::DISPLAYS_WITHOUT_IM_SETUP.index(display)
        nil
      else
        fork{ exec(IM_CMD % [display, *args]) }
      end
    }
  end
end
