#
#  setup INPUT-METHOD : Anthy (uim-xim) ( < 0.4.4 )
#
module TkORCA::Input_Method
  unless const_defined?('UIM_ENGINE')
    UIM_ENGINE = 'anthy'
  end

  ENV['XMODIFIERS']    = "@im=uim-#{UIM_ENGINE}"
  ENV['GTK_IM_MODULE'] = 'uim-anthy'
  ENV['QT_IM_MODULE']  = 'uim-anthy'
  ENV['TK_KCPROTO']    = 'xim'
  ENV['XIM_PROG']      = 'anthy'

  unless const_defined?('IM_PROG')
    IM_PROG = '/usr/bin/uim-xim'
  end

  unless const_defined?('IM_CMD')
    # IM_CMD = "#{IM_PROG} -display %1$s --engine=#{UIM_ENGINE}"
    IM_CMD = "#{IM_PROG}"
  end

  unless const_defined?('START_UP_PROC')
    START_UP_PROC = proc{|*args|
      if args.empty?
        display = ENV['DISPLAY']
      else
        display = args.shift
      end
      if display.empty? || TkORCA::DISPLAYS_WITHOUT_IM_SETUP.index(display)
        nil
      else
        fork{ exec(IM_CMD % [display, *args]) }
      end
    }
  end
end
