#
#  setup INPUT-METHOD : SKKinput2
#
module TkORCA::Input_Method
  ENV['XMODIFIERS'] = '@im=skkinput'
  ENV['TK_KCPROTO'] = 'kinput2'
  ENV['XIM_PROG']   = 'skk'

  unless const_defined?('IM_SERVER')
    if (ENV['SKKSERVER'])
      IM_SERVER = ENV['SKKSERVER']
    else
      # IM_SERVER = 'unix'
      IM_SERVER = 'localhost'
    end
  end
  ENV['SKKSERVER'] = IM_SERVER

  unless const_defined?('SKK_LANG')
    SKK_LANG = 'ja'
  end

  unless const_defined?('IM_PROG')
    IM_PROG = '/usr/X11R6/bin/skkinput'
  end

  unless const_defined?('IM_CMD')
    IM_CMD = "#{IM_PROG} -display %1$s"
  end

  unless const_defined?('START_UP_PROC')
    START_UP_PROC = proc{|*args|
      if args.empty?
        display = ENV['DISPLAY']
      else
        display = args.shift
      end
      if display.empty? || TkORCA::DISPLAYS_WITHOUT_IM_SETUP.index(display)
        nil
      else
        fork{ ENV['LANG'] = SKK_LANG; exec(IM_CMD % [display, *args]) }
      end
    }
  end
end
