#
#  replace_event_subst.rb : 
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
requrie 'tk/event.rb'
requrie 'tkorca/utils.rb'

class TkEvent::Event
  KEY_TBL.assoc(?X)[1] = ?X
  KEY_TBL.assoc(?Y)[1] = ?Y

  PROC_TBL.unshift([ ?X, 
                     proc{|lst|
                       xx, x, w = TkComm.list(lst)
                       if TkORCA.is_mother?
                         xx
                       else
                       if (x = TkComm.num_or_str(x)).kind_of?(Integer)
                         x - TkWinfo.rootx(w)
                       else
                         xx
                       end
                     }
                   ])

  PROC_TBL.unshift([ ?Y, 
                     proc{|lst|
                       yy, y, w = TkComm.list(lst)
                       if TkORCA.is_mother?
                         yy
                       else
                       if (y = TkComm.num_or_str(y)).kind_of?(Integer)
                         y - TkWinfo.rooty(w)
                       else
                         yy
                       end
                     }
                   ])

  remove_const 'SUBST_INFO'
  _setup_subst_table(KEY_TBL, PROC_TBL)

  class << self
    alias _orig_get_subst_key      _get_subst_key
    alias _orig_get_all_subst_keys _get_all_subst_keys

    def _get_subst_key(args)
      keys = _orig_get_subst_key(args)
      args.gsub!(/(^|\s)(%[XY])(?=$|\s)/, '\1{\2 %W}')
      keys
    end

    def _get_all_subst_keys
      keys, args = _orig_get_all_subst_keys
      args.gsub!(/(^|\s)(%[XY])(?=$|\s)/, '\1{\2 %W}')
      [keys, args]
    end
  end
end
