#
#  tkorca/setup/require_libs.rb : require libraries of Ruby/TkORCA
#
#                         by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#

###########################
##  utility methods
###########################
require 'tkorca/utils'
require 'tkorca/debug'
require 'tkorca/init_optiondb'
require 'tkorca/file_access'

###########################
##  main classes
###########################
require 'tkorca/window_frame'
require 'tkorca/rfb_canvas'
require 'tkorca/mother'
require 'tkorca/daughter'

###########################
##  tcl-command wrappers
###########################
require 'tkorca/tclcmd_wrapper'

require 'tkorca/wrap_toplevel_cmd'
require 'tkorca/wrap_grab_cmd'
require 'tkorca/wrap_wm_cmd'
require 'tkorca/wrap_winfo_cmd'
require 'tkorca/wrap_raise_and_lower_cmd'
require 'tkorca/wrap_tearoffmenu_cmd'
require 'tkorca/wrap_messagebox_cmd'

require 'tkorca/wrap_misc_tclcmd'
require 'tkorca/wrap_misc_tkcmd'

###########################
##  method wrappers
###########################
require 'tkorca/method_wrapper'

require 'tkorca/wrap_ObjectSpace'
require 'tkorca/wrap_IO'
require 'tkorca/wrap_functions'

require 'tkorca/wrap_tkvar_wait'

###########################
##  others
###########################
require 'tkorca/console'
