#
#  tkorca/setup/stage1.rb
#
#    STAGE-1 :  setup parameters before loading Ruby/Tk
#
#                         by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#

#################################
# define LANGUAGE ENVIRONMENT
#################################
# Ruby m17n (Ruby1.9+) ?
TkORCA::RUBY_M17N = Object.const_defined?(:Encoding) && ::Encoding.class==Class

if TkORCA::RUBY_M17N
  # depend on Tk -> fix at STAGE-2
else
  if TkORCA.const_defined?('KCODE')
    $KCODE = TkORCA::KCODE
    TkORCA::KCODE.replace($KCODE)
  else
    TkORCA::KCODE = $KCODE
  end

  unless TkORCA.const_defined?('ENCODING')
    case TkORCA::KCODE
    when /^e/i
      TkORCA::ENCODING = 'euc-jp'
    when /^s/i
      # 'cp932' or 'shiftjis' : depend on Tk.encoding_system -> fix at STAGE-2
    when /^u/i
      TkORCA::ENCODING = 'utf-8'
    else
      # depend on Tk.encoding_system -> fix at STAGE-2
    end
  end
end


#################################
# define INPUT-METHOD
#################################
unless TkORCA.const_defined?('USE_INPUT_METHOD')
  #TkORCA::USE_IMPUT_METHOD = nil
  TkORCA::USE_INPUT_METHOD = 'kinput2-canna'
end
unless TkORCA.const_defined?('DISPLAYS_WITHOUT_IM_SETUP')
  TkORCA::DISPLAYS_WITHOUT_IM_SETUP = [':0.0']
end
