#
#  tkorca/setup/stage2.rb
#
#    STAGE-2 :  setup parameters after loading Ruby/Tk, 
#                                but before starting an event-loop
#
#                         by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
######################################
#  setup the default mouse cursor
######################################
unless TkORCA.const_defined?('DEFAULT_MOUSE_CURSOR')
  TkORCA::DEFAULT_MOUSE_CURSOR = 'left_ptr'
end
TkOptionDB.add('*Tk*Cursor', TkORCA::DEFAULT_MOUSE_CURSOR, 
               TkOptionDB::Priority::WidgetDefault - 1)


######################################
#  setup ENCODING of Ruby/Tk
######################################
if TkORCA::RUBY_M17N
  # Ruby m17n (Ruby1.9+)
  enc_obj = ::Encoding.default_external
  TkORCA::KCODE = enc_obj.name
  enc_name = Tk::Encoding::ENCODING_TABLE.key(enc_obj)
  unless enc_name
    begin
      enc_name = Tk.encoding_system
    rescue StandardError, NameError
      enc_name = 'utf-8'
    end
  end
  TkORCA::ENCODING = enc_name
end

unless TkORCA.const_defined?('ENCODING')
  # $KCODE is 'SJIS' or 'NONE'
  if $KCODE =~ /^s/i
    # SJIS
    begin
      enc = Tk.encoding_system
    rescue StandardError, NameError
      enc = 'shiftjis'
    end
    if enc == 'cp932'
      TkORCA::ENCODING = 'cp932'
    else
      TkORCA::ENCODING = 'shiftjis'
    end
  else
    # NONE
    begin
      TkORCA::ENCODING = Tk.encoding_system
    rescue StandardError, NameError
      TkORCA::ENCODING = 'utf-8'
    end

    case TkORCA::ENCODING
    when 'euc-jp'
      $KCODE = 'euc'
      TkORCA::KCODE.replace($KCODE)
    when 'shiftjis', 'cp932'
      $KCODE = 'sjis'
      TkORCA::KCODE.replace($KCODE)
    when 'utf-8', 'unicode'
      $KCODE = 'utf-8'
      TkORCA::KCODE.replace($KCODE)
    end
  end
end
Tk.encoding = TkORCA::ENCODING
Tk.encoding_system = TkORCA::ENCODING
