#
#  wrap_grab_cmd.rb : wrap Tcl/Tk command `grab'
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
require 'tkorca/tclcmd_wrapper'

class << TkORCA::OPTIONS
  def allow_global_grab?(ip_name)
    @allow_global_grab ||= {}
    @allow_global_grab[ip_name]
  end

  def allow_global_grab_to(ip_name)
    TkORCA.security_check()
    @allow_global_grab ||= {}
    @allow_global_grab[ip_name] = true
  end

  def deny_global_grab_to(ip_name)
    TkORCA.security_check()
    @allow_global_grab ||= {}
    @allow_global_grab.delete(ip_name)
  end
end

class << TkORCA::TclCmdWrapper.entry_wrapper_module(Module.new)
  def replace_in(ip)
    TkORCA::TclCmdWrapper.convert_tcl_command_args(ip, 'grab', 
                                                   &(_create_proc()))
  end

  ###############################################################
  private
  ###############################################################
  ##
  ##  check arguments and return new argument list.
  ##
  ##  NOTE: Never call tcl commands on any Tcl interpreters. 
  ##        Somtimes, such call breaks callback transaction.
  ##
  ###############################################################
  def _create_proc
    @grab_table ||= {}
    proc{|ip, cmd, *args|
      if args[0][0] == ?- || args[0][0] == ?.
        subcmd = 'set'
      else
        subcmd = args.shift
      end

      unless false && TkORCA::OPTIONS.allow_global_grab?(ip.ip_name)
        args.shift if args[0][0] == ?-  # remove `-global'
      end

      # re =  /^#{subcmd}/
      # if 'set' =~ re && 'status' !~ re
      #   # set
      # elsif 'release' =~ re
      #   # release
      # end

      [subcmd, *args]
    }
  end

=begin
  def _argument_check(slave, *args)
    if args[0][0] == ?-
      # remove `-global' option
      args.shift
    end
    if args[0][0] == ?.
      # grab win ==> grab set win
      cmd = 'set'
    else
      cmd = args.shift
    end
    if cmd == 'set' && args[0][0] == ?-
      # remove `-global' option
      args.shift
    end
    TclTkLib._merge_tklist(cmd, *args)
  end
=end
end
