#
#  wrap_raise_and_lower_cmd.rb : wrap Tcl/Tk command `raise' and 'lower'
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
require 'tkorca/tclcmd_wrapper'

class << TkORCA::TclCmdWrapper.entry_wrapper_module(Module.new)
  def replace_in(ip)
    body = <<-EOS
    set win [lindex $args 0]
    set target [lrange $args 1 end]

    if {[string compare $win [interp eval $slave winfo toplevel $win]]} {
      # win is not toplevel
      return [eval interp invokehidden $slave $cmd $args]
    }

    # win is toplevel
    if {[catch {interp eval $slave $win cget -use} use]} {
      # no '-use' option (maybe menu widget and so on)
      return [eval interp invokehidden $slave $cmd $args]
    }

    if {[string compare $use ""] == 0} {
      # no frame -> no way for raise/lower
      return [eval interp invokehidden $slave $cmd $args]
    }

    set scrn [interp invokehidden $slave winfo screen $win]
    set tbl  [ruby "TkORCA::RFB_Canvas.get_wallpath_table_id"]
    set wall [set ${tbl}($scrn)]
    set container [winfo pathname -displayof $wall $use]
    set container_id [ruby "TkORCA::Window_Frame.get_container_id('${container}')"]
    set container_frame [$wall itemcget $container_id -window]

    if {[string compare $container_id ""] == 0} {
      # no TkcWindow -> no way for raise/lower
      return [eval interp invokehidden $slave $cmd $args]
    }

    if {[string compare $target ""] == 0} {
      $wall $cmd $container_id
      $cmd $container_frame
      return ""
    }

    set target [interp eval $slave winfo toplevel $target]

    if {[string compare $scrn [interp invokehidden $slave winfo screen $target]]} {
      # not on a same screen -> no way for raise/lower
      return [eval interp invokehidden $slave $cmd $args]
    }

    if {[catch {interp eval $slave $target cget -use} target_use]} {
      # no '-use' option (maybe menu widget and so on)
      return [eval interp invokehidden $slave $cmd $args]
    }

    if {[string compare $target_use ""] == 0} {
      # no frame -> no way for raise/lower
      return [eval interp invokehidden $slave $cmd $args]
    }

    set target_container [winfo pathname -displayof $wall $target_use]
    set target_container_id [ruby "TkORCA::Window_Frame.get_container_id('${target_container}')"]
    set target_container_frame [$wall itemcget $target_container_id -window]

    if {[string compare $target_container_id ""] == 0} {
      # no TkcWindow -> no way for raise/lower
      return [eval interp invokehidden $slave $cmd $args]
    }

    $wall $cmd $container_id $target_container_id
    $cmd $container_frame $target_container_frame
    return ""
    EOS

    TkORCA::TclCmdWrapper.wrap_tcl_command_transaction(ip, 'raise', <<-EOS)
    set cmd raise
    #{body}
    EOS

    TkORCA::TclCmdWrapper.wrap_tcl_command_transaction(ip, 'lower', <<-EOS)
    set cmd lower
    #{body}
    EOS
  end
end
