#
#  wrap_toplevel_cmd.rb : wrap Tcl/Tk command `toplevel'
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
require 'tkorca/tclcmd_wrapper'

class << TkORCA::TclCmdWrapper.entry_wrapper_module(Module.new)
  def replace_in(ip)
    TkORCA::TclCmdWrapper.wrap_tcl_command(ip, 'toplevel', &(_create_proc()))
    if TkNamespace.exist?('::tk')
      ip._eval('proc ::tk::toplevel {args} [info body ::toplevel]')
    end
  end

  ######################################
  private
  ######################################
  def _create_proc
    proc{|ip, cmd, *args|
      path = args.shift
      params = Hash[*args]

      if use = params['-use']
        if ip.safe?
          raise SecurityError, "refuse `-use' option for safe-interpreter"
        end
        TkORCA::LOG.log(TkORCA::Daughter._name(ip), "create toplevel #{path}")
        MultiTkIp.invoke_hidden(ip, 'toplevel', path, *args)
      else
        wall = TkORCA::RFB_Canvas.get_wall_for_screen(params['-screen'])
        win = TkORCA::Window_Frame.new(wall, path)
        TkORCA::LOG.log(TkORCA::Daughter._name(ip), "create toplevel #{path}")
        MultiTkIp.invoke_hidden(ip, 'toplevel', path, '-use', win.winid, *args)
      end
      path
    }
  end
end
