#
#  wrap_winfo_cmd.rb : wrap Tcl/Tk command `winfo'
#
#                           by Hidetoshi NAGAI (nagai@ai.kyutech.ac.jp)
#
require 'tkorca/tclcmd_wrapper'

class << TkORCA::TclCmdWrapper.entry_wrapper_module(Module.new)
  def replace_in(ip)
    get_wall = <<-EOS
      set scrn [interp invokehidden $slave winfo screen $params]
      set wall [ruby "TkORCA::RFB_Canvas.get_wallpath_for_screen('$scrn')"]
    EOS

    TkORCA::TclCmdWrapper.wrap_tcl_command_transaction(ip, 'winfo', <<-EOS)
    set subcmd [lindex $args 0]
    set params [lrange $args 1 end]

    switch -exact -- $subcmd {
      geometry {
        if {$params eq [interp eval $slave winfo toplevel $params]} {
          # is toplevel
          set use [eval interp eval $slave $params cget -use]
          if {$use eq ""} {
            # no frame
            eval interp invokehidden $slave winfo geometry $params

          } else {
            #{get_wall}
            set container [winfo pathname $use]
            if [winfo ismapped $container] {
              set w [winfo width  $container]
              set h [winfo height $container]
            } else {
              set w [winfo reqwidth  $container]
              set h [winfo reqheight $container]
            }

            format "%dx%d+%d+%d" \
                   $w $h [winfo rootx $container] [winfo rooty $container]
          }

        } else {
          # not toplevel
          eval interp invokehidden $slave winfo geometry $params
        }
      }

      vrootx {
        #{get_wall}
        expr int([$wall canvasx 0] - [winfo rootx $wall])
      }

      vrooty {
        #{get_wall}
        expr int([$wall canvasy 0] - [winfo rooty $wall])
      }

      default {
        eval interp invokehidden $slave winfo $subcmd $params
      }
    }
    EOS
  end
end
